﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ListViewSample.BusinessObjects
{
    public class Address : INotifyPropertyChanged
    {

        #region Fields

        private string town;

        #endregion

        #region Properties

        public string Town
        {
            get { return town; }
            set
            {
                town = value;
                RaisedOnPropertyChanged("Town");
            }
        }

        #endregion

        #region INotifyPropertyChanged Interface

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

        #endregion
    }
}
