﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace ListViewSample.BusinessObjects
{
    public class CustomerInfo : INotifyPropertyChanged
    {
        #region Command

        ICommand itemcommand;

        public ICommand ItemCommand
        {
            get { return itemcommand; }
            set
            {
                itemcommand = value;
                RaisedOnPropertyChanged("ItemCommand");
            }
        }

        #endregion

        #region Fields

        private string name;
        private Address address;
        private int _sortKey = 0;
        private int calculatedValue = 5;

        #endregion

        #region Constructor

        public CustomerInfo(string name, string town)
        {
            itemcommand = new Command(ItemImageTapped);

            this.Name = name;

            this.Address = new Address();
            if (town.Contains("0"))
            {
                Address.Town = string.Empty;
            }
            else
            {
                Address.Town = town;
            }
        }

        #endregion

        #region Properties

        public string Name
        {
            get { return name; }
            set
            {
                name = value;
                RaisedOnPropertyChanged("Name");
            }
        }

        public Address Address
        {
            get { return address; }
            set
            {
                address = value;
                RaisedOnPropertyChanged("Address");
            }
        }

        public string Town
        {
            get { return Address.Town; }
        }

        public int SortKey
        {
            get { return _sortKey; }
            set
            {
                _sortKey = value;
                RaisedOnPropertyChanged("SortKey");
            }
        }

        public int CalculatedValue
        {
            get
            {
                if (calculatedValue == 5)
                    calculatedValue = 1;
                return calculatedValue;
            }
         
        }

        #endregion

        #region INotifyPropertyChanged Interface

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

        #endregion

        #region Methods

        public void ItemImageTapped() 
        {

        }

        #endregion
    }

    public class StandardCustomer : CustomerInfo
    {
        #region Fields

        private Address officeaddress;
        private string officeName;

        #endregion

        #region Constructor

        public StandardCustomer(string name, string town) : base(name, town)
        {
        }

        #endregion

        #region Properties

        public string OfficeName
        {
            get { return officeName; }
            set
            {
                officeName = value;
                RaisedOnPropertyChanged("OfficeName");
            }
        }

        public Address OfficeAddress 
        {
            get { return officeaddress; }
            set
            {
                officeaddress = value;
                RaisedOnPropertyChanged("OfficeAddress");
            }
        }

        #endregion

    }
}
