﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ListViewSample.BusinessObjects
{
    public class EmployeeInfo : INotifyPropertyChanged
    {
        #region Fields

        private ObservableCollection<CustomerInfo> _customers;
        private int _group;
        private CustomerInfo selectedCustomer;

        #endregion

        #region Constructor

        public EmployeeInfo(List<CustomerInfo> customers, int group)
        {
            Customers = new ObservableCollection<CustomerInfo>(customers);
            Group = group;
        }

        #endregion

        #region Properties

        public CustomerInfo SelectedCustomer
        {
            get { return selectedCustomer; }
            set
            {
                selectedCustomer = value;
                RaisedOnPropertyChanged("SelectedCustomer");
            }
        }

        public int Group
        {
            get { return _group; }
            set
            {
                _group = value;
                RaisedOnPropertyChanged("Group");
            }
        }

        public ObservableCollection<CustomerInfo> Customers
        {
            get { return _customers; }
            set
            {
                _customers = value;
                RaisedOnPropertyChanged("Customers");
            }
        }

        #endregion

        #region INotifyPropertyChanged Interface

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

        #endregion
    }
}
